/*--------------------------------------------------------------------------
  HARDCONF is a mini programming language intended to be used to configure
  the ST when booting a hard disk system, although it could equally be used
  with floppy drives.
  
  Revision 1.1 by Les Kneeling 1990
--------------------------------------------------------------------------*/
#include <osbind.h>
#include <stdio.h>
#include <fcntl.h>
#include <define.h>
#include <string.h>
#include <ctype.h>

char *version = "HardConf 1.1 (c) Les Kneeling 1989\n";

char line[80], word[40], word2[40];
short storage[512];
int ParseCount, WordCount, Skip=FALSE, error, x, y, date, temp;
FILE *stream;
long system_screen;
char *screen2;

main()
    {
    int instcount;
    instcount = 0;
    system_screen = Logbase();          /* Find the normal screen       */
    screen2 = calloc( 32768 + 256, 1 ); /* Reserve memory for second    */
                                        /* screen and make sure that it */
                                        /* is on a page boundary        */
    if((long)screen2 & 0xff)
        screen2 = screen2 + (0x100 - (long)screen2 & 0xff );

    stream = fopen( "hard.sys", "r");   /* Open stream to sys file      */
    if( stream != 0l )
        {
        fgets( line, 80, stream );      /* Read-ahead the first line    */
        while(! feof(stream)){          /* Keep going until sys file    */
            instcount++;                /* exhausted                    */
            ParseCount = 0;
            if( Parse() )               /* If cannot parse the line     */
                printf("Error line %d\n", instcount);
                                        /* Display error message        */
            fgets( line, 80, stream );  /* and carry on                 */
            };
        fclose( stream );               /* Finished - close stream      */
        }
    free( screen2 );                    /* Release memory               */
    exit(0);
    }

Parse()                                 /* Figure out what the line     */
    {                                   /* means                        */
    int temp;
    
    NextWord();                         /* Get the next word            */
    error = Decode( word );             /* Do we know what it means?    */
    for(temp = 0; temp <= WordCount; temp++ )
        word[temp] = 0;
    return error;
}

NextWord()                              /* Get the next word from the   */
    {                                   /* line                         */
    WordCount = 0;
    while(isspace(line[ParseCount]))
        ParseCount++;                   /* Dispose of spaces etc.       */
    while(!(isspace(line[ParseCount]))) /* Read until a space is reached*/
        {
        word[WordCount] = line[ParseCount];
        ParseCount++;
        WordCount++;
        }
    word[WordCount] = 0;
    }

Decode( word )                          /* What does the word mean?     */
    char *word;
    {
    int error=FALSE, key, res, pressed, temp;
    
    if(!(strncmp(word,"endif",5)))      /* If the skip flag is TRUE     */
        Skip = FALSE;                   /* an IF statement is in action */
    else if(Skip == FALSE && !(strncmp(word,"time",4)))
        show_time();
    else if(Skip == FALSE && !(strncmp(word,"settime",7)))
        set_time();
    else if(Skip == FALSE && !(strncmp(word,"date",4)))
        show_date();
    else if(Skip == FALSE && !(strncmp(word,"flip",4)))
        flip_screen();
    else if(Skip == FALSE && !(strncmp(word, "back", 4)))
        flip_back();
    else if(Skip == FALSE && !(strncmp(word,"setdate",7)))
        set_date();
    else if(Skip == FALSE && !(strncmp(word,"cls",3)))
        printf("%cE", 27 );
    else if(Skip == FALSE && !(strncmp(word,"clrto",5)))
        printf("%cd", 27 );
    else if(Skip == FALSE && !(strncmp(word,"clrfm",5)))
        printf("%cJ", 27 );
    else if(Skip == FALSE && !(strncmp(word,"reverse",7)))
        printf("%cp", 27 );
    else if(Skip == FALSE && !(strncmp(word,"normal",5)))
        printf("%cq", 27 );
    else if(Skip == FALSE && !(strncmp(word,"key",3)))
        key = Cconin();
    else if(Skip == FALSE && !(strncmp(word,"vers",4)))
        puts( version );
    else if(Skip == FALSE && !(strncmp(word,"load1",5)))
        {
        NextWord();
        do_screen(1);
        }
    else if(Skip == FALSE && !(strncmp(word,"load2",5)))
        {
        NextWord();
        do_screen(2);
        }
    else if(Skip == FALSE && !(strncmp(word,"drive",5)))
        {
        NextWord();
        Dsetdrv( line[ParseCount-1]-'A');
        Dsetpath("\\");
        }
    else if(Skip == FALSE && !(strncmp(word,"copy",4)))
        do_copy();
    else if(Skip == FALSE && !(strncmp(word, "rename", 6 )))
        do_rename();
    else if(Skip == FALSE && !(strncmp(word,"run",3)))
        {
        NextWord();
        do_execute();
        }
    else if(Skip == FALSE && !(strncmp(word,"wait",4)))
        {
        NextWord();
        NextWord();
        NextWord();
        NextWord();
        key = 0;
        do  {
            key = Cconin();
            }while( key != word[0]);
        }
    else if(Skip == FALSE && !(strncmp(word,"cursor",6)))
        {
        NextWord();
        curpos(word);
        }
    else if(Skip == FALSE && !(strncmp(word,"rem",3)))
        {
        ParseCount++;
        while(line[ParseCount] != 0)
            {
            putchar(line[ParseCount]);
            ParseCount++;
            }
        error = FALSE;
        }
    else if (Skip == FALSE && !(strncmp(word,"if",2)))
        {
        NextWord();
        if(!(strncmp(word,"key",3)))
            {
            NextWord();
            NextWord();
            key = Crawcin();
            if(key == word[0])
                {
                Parse();
                Skip = FALSE;
                }
            else Skip = TRUE;
            }
        else if(!(strncmp(word,"pressed",7)))
            {
            NextWord();
            NextWord();
            if(!(strncmp(word,"ALT",3)))
                key = 8;
            else if(!(strncmp(word,"CTRL",4)))
                key = 4;
            else if(!(strncmp(word,"SHIFT",5)))
                key = 2;
            else error = TRUE;
            if(!error)
                if(key == Kbshift(-1))
                    {
                    Skip = FALSE;
                    Parse();
                    }
                else
                    {
                    Skip = TRUE;
                    Parse();
                    }
            }
        else if(!(strncmp(word,"date",4)))
            {
            NextWord();
            NextWord();
            date = Tgetdate();
            temp = decode();
            if(date == temp)
                {
                Skip = FALSE;
                Parse();
                }
            else
                {
                Skip = TRUE;
                Parse();
                }
            }
        else if(!(strncmp(word,"res",3)))
            {
            NextWord();
            NextWord();
            res = Getrez();
            if((res == 2) && !(strncmp(word,"HIGH",4)))
                    Parse();
            else if((res == 1) && !(strncmp(word,"MED",3)))
                    Parse();
            else if((res == 0) && !(strncmp(word,"LOW",3)))
                    Parse();
            else Skip = TRUE;
            }
        }
    else if(Skip == TRUE)
        error = FALSE;
    else
        error = TRUE;
    return error;
    }

curpos( string )                        /* Read a cursor position from  */
char *string;                           /* the line and convert it into */
    {                                   /* a VT52 cursor command        */
    int count;
    
    do  {
        ParseCount++;
        }while( !isdigit(line[ParseCount]) );
    sscanf( word, "%d,%d", &x, &y );
    printf( "%cY%c%c", 27, 32+y, 32+x);
    }
    
decode()                                /* Read a number from the line  */
    {
    int temp;
    
    sscanf( word, "%d", &temp );
    return temp;
    }

do_screen( which )                      /* Read a Degas file into one   */
int which;                              /* of the screens               */
    {
    int fd, count;

    fd = open( word, O_RDONLY|O_BINARY);
    if( which == 1 )
        if( fd > 0 )
            {
            read( fd, system_screen, 34);
            read( fd, system_screen, 32000);
            close(fd);
            }
        else error = TRUE;
    else
        if( fd > 0 )
            {
            read( fd, screen2, 34);
            read( fd, screen2, 32000);
            close(fd);
            }
        else error = TRUE;
    }

do_copy()                               /* Copy a file                  */      
    
{
int source, dest;
long rd, rt;
long avail;
char fmtbuf[512];
char name1[64], name2[64];

NextWord();
strcpy( name1, word );                  /* File to copy from            */
NextWord();
strcpy( name2, word );                  /* File to copy to              */
avail = 512;
    source = Fopen( name1, 0 );
    dest = Fcreate( name2, 0);
    if( (source < 0) || (dest < 0))
        puts("Error");
    else{
        do  {
            rd = Fread( source, avail, fmtbuf );
            rt = Fwrite( dest, rd, fmtbuf );
            }while( rd != 0 );
        Fclose( source );
        Fclose( dest );
        }
}

do_rename()                             /* Rename a file                */
    {
    int fd;
    unsigned count;

    NextWord();
    strcpy( word2, word );
    NextWord();
    Frename( 0, word2, word );
    }
    
do_execute()                            /* Run a program                */
    {
    int err;
    char *cl, *env;

    err = Pexec( 0, word, cl, env);
    if(err < 0)
        error = TRUE;
    }

show_date()                             /* Display the current date     */
    {
    unsigned date;
    int day, month, year;
    
    date = Tgetdate();
    day = date&31;
    date >>= 5;
    month = date&15;
    date >>= 4;
    date += 80;
    printf("Date is :%d/%d/%d\n", day, month, date);
    }

set_date()                              /* Set the date                 */
    {
    unsigned date, day, month, year;
    
    printf(" ");
    show_date();
    printf("New date :%ce", 27);
    scanf("%2d %*1c %2d %*1c %2d", &day, &month, &year);
    if((year > 80) && (month < 13) && (day < 32))
        {
        date=year-80;
        date <<= 4;
        date += month;
        date <<= 5;
        date += day;
        Tsetdate( date );
        }
    printf("%cf", 27);
    }

show_time()                             /* Show the current time        */
    {
    unsigned time, mins, secs;
    
    time = Tgettime();
    secs = (time&31)*2;
    time >>= 5;
    mins = time&63;
    time >>= 6;
    printf("Time is :%02d:%02d:%02d\n", time, mins, secs);
    }

set_time()                              /* Set the time                 */
    {
    unsigned time, secs, mins, hours;
    
    printf(" ");
    show_time();
    printf("New time :%ce", 27);
    scanf("%2d %*1c %2d %*1c %2d", &hours, &mins, &secs);
    if((hours < 25) && (mins < 61) && (secs < 61))
        {
        time = hours;
        time <<= 6;
        time += mins;
        time <<= 5;
        time += secs/2;
        Tsettime( time );
        }
    printf("%cf", 27);
    }

flip_screen()                           /* Switch to the second screen  */
{
    printf("%cj\n", 27 );   /* Store cursor position */
    Setscreen( screen2, screen2, -1 );
}

flip_back()                             /* Return to the normal screen  */
{
    Setscreen( system_screen, system_screen, -1 );
    printf("%ck%cB%cB\n", 27, 27, 27 );
}
